#ifndef BFBUCKET_H
#define BFBUCKET_H

class BFBucket {
private:
    static int numBFBuckets;
  static class BFBucket*	freeBucket;  // alloc and free buffer 
public:
  int		bufIndex;	// index into buftable 
  PID           pid;
  global_event  *ioComplete;    // signals when io complete 
  short         inTransit;      // TRUE if undergoing IO 
  BFBucket* 	next;

  BFBucket() {
    bufIndex = ILLEGAL_BUFINDEX;   
    next = 0;
    pid.diskId = ILLEGAL_DISK;
    pid.pageId = ILLEGAL_PAGE;
    ioComplete = NIL;
    inTransit = FALSE;
  };

  inline void* operator new(size_t size);  // new is overloaded 
  inline void operator delete(void* oldBucket);
};

inline void* BFBucket::operator new(size_t size)
{
    BFBucket *newBucket;

    if (freeBucket == NULL) {
        // allocate a new bucket
        newBucket = (BFBucket *) new char[size];
	if (Flags[TRACE_LEAK])
	  printf("new bufbucket %d\n", ++numBFBuckets);
      } else {
        // reuse an existing bucket
        newBucket = freeBucket;
        freeBucket = freeBucket->next;
      }
    return newBucket;
  };


inline void BFBucket::operator delete(void* oldBucket)
{
    // put the bucket on the free list
    ((BFBucket *) oldBucket)->next = freeBucket;
    freeBucket = (BFBucket *) oldBucket;
  };

#endif

