#include "dbsim.h"
#include "object.h"
#include "node.h"
#include "split.h"
#include "language.h"
#include "db.h"
#include "op.h"
#include "query.h"

int SelectOp::numSelectOps = 0;
int ScanOp::numScanOps = 0;
int StoreOp::numStoreOps = 0;
int TermOp::numTermOps = 0;
int JoinOp::numJoinOps = 0;

SelectOp* SelectOp::freeSelectOp = NULL;
ScanOp* ScanOp::freeScanOp = NULL;
StoreOp* StoreOp::freeStoreOp = NULL;
TermOp* TermOp::freeTermOp = NULL;
JoinOp* JoinOp::freeJoinOp = NULL;


Op::Op(Node* n)
{
    node = n;     // save the node
    initiator = NULL;
    outTupSize = 0;
    inTupSize = 0;
};

SelectOp::SelectOp(Node* n): Op(n)
{
    file = NULL;
    index = NULL;
    selFactor = 0.0;
    indexSelectivity = 0.0;
    diskId = -1;
};

SelectOp::~SelectOp(){
    delete splitTable;
};

ScanOp::ScanOp(Node* n): Op(n)
{
    file = NULL;
    index = NULL;
    diskId = -1;
};

StoreOp::StoreOp(Node* n): Op(n)
{
    file = NULL;
    diskId = -1;
    inStreams = 0;
};

JoinOp::JoinOp(Node* n): Op(n)
{
    selFactor = 0.0;
    inTupSizeR = 0;
    inTupSizeL = 0;
    tupsPerNetPageOut = 0;
    inStreamsL = 0;
    inStreamsR = 0;
};

JoinOp::~JoinOp() {};

