#include "disk.h"

///////////////////////////////////////////////////////////////////////////////
//
//  Name:        node.h
//
//  Title:       UW database simulator node class definition.
//
//  Change Activity:
//
//     08/15/91 (KPB) - Initial version.
//     11/26/91 (DDW) - modified disks to be an array of pointers to disks 
//		and changed node constructor accordingly
//
///////////////////////////////////////////////////////////////////////////////

class BufMgr;
class Mailbox;

class Node {
  public:
    int id;                         // node Identifier
    Mailbox *lddPort;               // local deadlock detector process port
    Mailbox *nodeMgrPort;           // node manager process port
    BufMgr* bufMgr;		    // buffer pool 
    Disk *disks[MAX_DISKSPERNODE];  // array of pointers to disk objects
    facility_ms cpu;                // cpu(s) for this node    

    Node(int id);
    ~Node();
    void startBufMgr();             // instantiate buf mgr -- called after
                                    // database has been defined.
    float avgQlen();                // return mean qlength across all disks
    void printCPUStats();
    void printDiskStats();
};

