// This sample configuration file specifies all the possible keywords, even 
// though nearly all of them are optional.  See the PRPL documentation in 
// doc/prpl.ps for a list of default values.

nodes = <population = 4,          // # processing nodes 
         disks = 3,               // # disks per node
         cpus = 2,                // # CPUs per node
         cpumips = 30,            // MIPS per CPU
         kbytes = 16384,          // kbytes of RAM per node
         pagesize = 8192,         // page size in bytes
         inst_startio = 5000>;    // # instructions required to start an I/O

disks = <pages/cyl = 33,          // pages per cylinder
         minlatency = 0,          // minimum latency
         settle = 2,              // average settle time
         rotation = 16.667,       // msecs to complete one revolution
         seekfactor = .78,        // Bitton/Gray seek time formula factor
         xferrate = 4.0,          // transfer rate in MB/sec
         cachepages = 5,          // # pages per cache context
         cachecontexts = 16>;     // # cache contexts

network = <maxrequests = 1,       // max requests that can concurrently be 
                                  // active (1 implies a bus-like topology)
         minsendprotocol = 1000,  // min # CPU instructions to send a msg
         sendprotocol/byte = 4,   // additional CPU instructions for ea byte
         minrecvprotocol = 1000,  // min # CPU instructions to receive a msg 
         recvprotocol/byte = 4,   // additional CPU instructions for ea byte
         mindelay = .835,         // minimum wire delay in msecs
         delay/byte = 0.000582,   // additional wire delay per byte (msecs)
         minshortinstr = 5000,    // min # instruction to send a "short-
                                  // circuited" message (within the same node)
         shortinstr/byte = .157,  // additional CPU instructions for each byte
         globpoolkbytes = 256,    // kbytes of global message buffer pool mem
         locpoolkbytes = 16>;     // kbytes of local (per process) msg pool mem

// note that the maxpacketbytes network statement keyword of PRPL is not yet 
// supported by ZetaSim.  It currently defaults to 8192.

real selDist = uniform(.6666, 1.0); // Selectivity used in sample.w file

