// A single node, single tuple index lookup.

plan probeBig = termsend(iscan{random(0,2) * 1}(bigUnclIndex, 0.0, 0.0));

// An index selection which returns 1% of the indexed tuples -- the index
// itself selects 5% of the indexed tuples, and other "non-SARGable" predicates
// filter out the rest.

plan iscan10Percent (stats) = termsend(iscan(indexSequence, 0.01, 0.05));

// Simple binary join of two of the "medium" query files

plan binaryJoin  =
	termsend(hjoin[1.0 min, 1.0 max](
		fscan(queryFileMed, selDist),
		fscan(queryFileMed, selDist), 0.5, 0.5));

// Left deep six-way join using the small query files

plan j1 = hjoin(fscan(queryFileSmall, selDist),
		fscan(queryFileSmall, selDist), 0.5, 0.5);
plan j2 = hjoin[1.0 min, .5 bpool](j1, fscan(queryFileSmall, selDist), .5, .5);
plan j3 = hjoin(j2, fscan(queryFileSmall, selDist), 0.5, 0.5);
plan j4 = hjoin[1.0 min, .5 max](j3, fscan(queryFileSmall, selDist), .5, .5);
plan j5 = hjoin(j4, fscan(queryFileSmall, selDist), 0.5, 0.5);
plan sixWay (stats) = termsend(j5);

// A bushy four-way join

plan bushy = termsend(hjoin(j1, j1, 0.5, 0.5));

// An "ad hoc" query class that executes a wide range of plans

plan adhocPlans = <iscan10Percent, binaryJoin, sixWay, bushy>;
class adhoc = <population = 5, maxmpl = 3, plans = <adhocPlans*100>,
	thinksecs = exponential(60), primary, maxcompletions = 12>;

// A rifle-shot transaction class

class rifleShot = <statwaitsecs = 10, population = 100, maxmpl = 100,
	plans = [probeBig], thinksecs = exponential(40)>;



